<template>
  <div>
    <el-card>
      <el-form :model="codeQuery" class="query-form" size="mini" label-width="100px">
        <el-row>
          <el-col :span="18">
            <el-form-item class="query-form-item" label="扫码查询:">
              <el-input v-model="codeQuery.code"
                        style="width: 97%"
                        placeholder="请扫描或输入UDI码"
                        clearable="true"
                        @keyup.enter.native="keyup_submit($event)"></el-input>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="6">
            <el-form-item class="query-form-item" label="预验收单号:">
              <el-input v-model="codeQuery.orderId" placeholder="预验收单号"
                        style="width: 90%"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item label="余量状态:">
              <el-select v-model="codeQuery.status" style="width: 90%" placeholder="请选择状态" clearable>
                <el-option label="在库" value="1"></el-option>
                <el-option label="已使用" value="2"></el-option>
                <el-option label="已退回" value="3"></el-option>
              </el-select>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item class="query-form-item" label="收货仓库:">
              <el-select v-model="codeQuery.invCode" placeholder="请选择收货仓库" clearable="true"
                         style="width: 90%"
              >
                <el-option
                  v-for="item in invList"
                  :key="item.name"
                  :label="item.name"
                  :value="item.code">
                  <span style="float: left">{{ item.name }}</span>
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>

          <el-col :span="6">
            <el-form-item class="query-form-item" label="收货时间:">
              <el-date-picker
                :picker-options="pickerOptions"
                v-model="auditDateRange"
                type="daterange"
                format="yyyy 年 MM 月 dd 日"
                value-format="yyyy-MM-dd"
                range-separator="至"
                start-placeholder="开始日期"
                end-placeholder="结束日期"
                style="width: 90%"
              >
              </el-date-picker>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="6">
            <el-form-item class="query-form-item" label="DI/物资编码:">
              <el-input v-model="codeQuery.nameCode" placeholder="DI/物资编码"
                        style="width: 90%"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item class="query-form-item" label="物资名称:">
              <el-input v-model="codeQuery.cpmctymc" placeholder="物资名称"
                        style="width: 90%"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>

          <el-col :span="6">
            <el-form-item class="query-form-item" label="规格型号:">
              <el-input v-model="codeQuery.ggxh" placeholder="规格型号"
                        style="width: 90%"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>

          <el-col :span="6">
            <el-form-item class="query-form-item" label="批次号:">
              <el-input v-model="codeQuery.batchNo" placeholder="批次号"
                        style="width: 90%"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>

        </el-row>
        <el-row>

          <el-col :span="6">
            <el-form-item class="query-form-item" label="生产企业:">
              <el-input v-model="codeQuery.ylqxzcrbarmc" placeholder="生产企业"
                        style="width: 90%"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
          <el-col :span="6">
            <el-form-item class="query-form-item" label="注册/备案号:">
              <el-input v-model="codeQuery.zczbhhzbapzbh" placeholder="注册/备案号"
                        style="width: 90%"
                        clearable="true"></el-input>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>

      <div class="top-right-btn">
        <el-button-group>
          <el-button icon="el-icon-view" type="primary" @click="hideSearch">显示/隐藏搜索栏</el-button>
          <el-button
            type="primary"
            icon="el-icon-refresh"
            @click="onCodeReset"
          >重置
          </el-button>
          <el-button type="primary" icon="el-icon-search" @click="onCodeSubmit"
          >查询
          </el-button
          >
        </el-button-group>
      </div>
      <el-divider style="margin: 15px"></el-divider>

      <el-table v-loading="codeDetailLoading" :data="codeDetailList" style="width: 100%" border
                row-key="id"
      >
        <el-table-column label="序号" type="index"></el-table-column>
        <el-table-column label="供应商" prop="fromName" v-if="showSup" show-overflow-tooltip
                         width="160"></el-table-column>
        <el-table-column
          label="审核时间"
          prop="auditTime"
          width="160"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column
          label="预验收单号"
          prop="orderId"
          width="160"
          show-overflow-tooltip
        ></el-table-column>


        <el-table-column
          label="物资名称"
          prop="productName"
          width="160"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column
          label="规格型号"
          prop="ggxh"
          width="160"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column
          label="批次号"
          prop="batchNo" width="120"
          show-overflow-tooltip
        ></el-table-column>

        <el-table-column
          label="入库数量"
          prop="originReCount" width="100"
        ></el-table-column>
        <el-table-column
          label="使用数量"
          width="100"
        >
          <template slot-scope="scope">
            <span>{{ scope.row.originReCount - scope.row.reCount }}</span>
          </template>
        </el-table-column>
        <el-table-column
          label="剩余数量"
          prop="reCount" width="100"
        ></el-table-column>

        <el-table-column
          label="退回数量"
          prop="returnCount" width="100"
        ></el-table-column>

        <el-table-column
          label="计量单位"
          prop="measname" width="100"
        ></el-table-column>
        <el-table-column label="余量状态" prop="status">
          <template slot-scope="scope">
            <el-tag :type="(scope.row.status)">
              {{ statusMap[scope.row.status] }}
            </el-tag>
          </template>
        </el-table-column>
        <el-table-column
          label="所属仓库"
          prop="invName"
          width="120"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column
          label="生产日期"
          prop="produceDate"
          width="100"
        ></el-table-column>
        <el-table-column
          label="失效日期"
          prop="expireDate"
          width="100"
        ></el-table-column>
        <el-table-column
          label="序列号"
          prop="serialNo"
          width="120"
        ></el-table-column>

        <el-table-column
          label="UDI码"
          prop="code"
          width="180"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column
          label="生产企业"
          prop="manufactory"
          width="160"
          show-overflow-tooltip
        ></el-table-column>
        <el-table-column
          label="注册/备案号"
          prop="zczbhhzbapzbh"
          width="160"
          show-overflow-tooltip
        ></el-table-column>

      </el-table>
      <pagination
        v-show="codeTotal>0"
        :total="codeTotal"
        :page.sync="codeQuery.page"
        :limit.sync="codeQuery.limit"
        @pagination="getCodeDetailList"
      />
    </el-card>
  </div>
</template>

<script>
import {
  deleterPrein,
  filterPrein, filterDetail
} from "@/api/inventory/invPreInSearch";
import {getLocalJoinByUser} from "@/api/basic/busType";
import {isBlank} from "@/utils/strUtil";
import {getBasicUnitMaintains} from "@/api/basic/basicUnitMaintain";
import store from "@/store";


const formJson = {
  site_id: "",
  site_name: "",
  describe: "",
  ads: [],
};

export default {
  name: "InvPreInSerach",
  data() {
    return {
      showSearch: true,
      invList: [],
      list: [],
      total: 0,
      loading: false,
      index: null,
      enableDept: false,
      fromTypeMap: {
        "1": "UDIMS平台",
        "2": "网页新增",
        "3": "pda即时校验",
        "4": "pda未校验",
        "5": "pc端扫码精灵",
        "6": "流转自动补单",
        "7": "UDI供应商平台",
        "8": "平衡补录单据",
        "10": "手动补单",
        "11": "仓库盘点",
        "12": "采购计划",
        "13": "领用单据",
        "14": "第三方系统单据",
      },
      deleteData: {
        orderId: null,
      },
      dialogTableVisible: false,
      formLoading: false,
      dialogVisible: false,
      formData: formJson,
      deleteLoading: false,
      busTypes: [],
      currentRow: {},
      actDateRange: [],
      pickerOptions: {
        shortcuts: [
          {
            text: "最近一周",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 7);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近一个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 30);
              picker.$emit("pick", [start, end]);
            },
          },
          {
            text: "最近三个月",
            onClick(picker) {
              const end = new Date();
              const start = new Date();
              start.setTime(start.getTime() - 3600 * 1000 * 24 * 90);
              picker.$emit("pick", [start, end]);
            },
          },
        ],
      },
      codeQuery: {
        code: null,
        orderId: null,
        status: null,
        invCode: null,
        nameCode: null,
        cpmctymc: null,
        ggxh: null,
        batchNo: null,
        ylqxzcrbarmc: null,
        zczbhhzbapzbh: null,
        page: 1,
        limit: 10
      },
      codeTotal: 0,
      codeDetailLoading: false,
      codeDetailList: [],
      fromOptions: [],
      auditDateRange: [],
      showSup: false,
      statusMap: {
        1: "在库",
        2: "已使用",
        3: "已退回",
      }
    };
  },
  components: {},
  methods: {
    onReset() {
      this.$router.push({
        path: "",
      });
      this.getList();
    },
    onSubmit() {
      this.loading = true;

      if (this.auditDateRange !== null) {
        this.codeQuery.startAduditTime = this.auditDateRange[0];
        this.codeQuery.endAduditTime = this.auditDateRange[1];
      } else {
        this.codeQuery.startAduditTime = null;
        this.codeQuery.endAduditTime = null;
      }
      this.codeQuery.page = 1;
      this.getList();
    },
    hideSearch() {
      this.showSearch = !this.showSearch;
    },
    getBusType() {
      let query = {
        code: this.filterQuery.invCode,
        enabled: true,
      };
      getLocalJoinByUser(query)
        .then((response) => {
          this.busTypes = response.data.list || [];
          this.filterQuery.action = this.busTypes[0].action;
        })
        .catch(() => {
        });
    },
    handleSelectionChange(val) {
      this.currentRow = val;
      this.getOrderDetails();
    },

    getOrderDetails() {
      this.codeQuery.page = 1;
      this.getCodeDetailList();
    },
    clearDetailList() {
      this.codeDetailList = [];
      this.codeTotal = 0;
    },
    //获取订单列表
    getList() {
      this.loading = true;
      this.currentRow = {billNo: ""};
      this.clearDetailList();
      this.filterQuery.fromCorp = store.getters.customerId
      filterPrein(this.filterQuery)
        .then((response) => {
          this.loading = false;
          if (response.code === 20000) {
            this.list = response.data.list || [];
            this.total = response.data.total || 0;
          } else {
            this.$message.error(response.message);
          }
        })
        .catch((error) => {
          this.$message.error(error.message)
          this.loading = false;
          this.list = [];
          this.total = 0;
        });
    },
    deleteOrders(data) {
      this.loading = true;
      let delQuery = {
        billNo: data,
      }
      deleterPrein(delQuery)
        .then((response) => {

          if (response.code == 20000) {
            this.getList();
            this.$message({
              type: "success",
              message: "删除成功！",
            });
          } else if (response.code == 520) {
            this.$message.error("新增扫码单据列表已不存在该扫码单据！");
            this.getList();
          }

        })
        .catch(() => {
        });
    },
    deleteDialog(row) {
      this.$confirm("此操作将永久删除该订单, 是否继续?", "提示", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          this.deleteOrders(row.billNo);
        })
        .catch(() => {
        });
    },
    onCodeReset() {
      this.codeQuery = {
        orderIdFk: null,
        page: 1,
        limit: 10
      };
      this.getCodeDetailList();
    },

    keyup_submit(event) {
      this.filterQuery.page = 1;
      this.getList();
      event.target.select();
    },

    onCodeSubmit() {
      this.codeQuery.page = 1;
      this.getCodeDetailList();
    },
    getCodeDetailList() {
      this.codeDetailLoading = true;
      this.codeQuery.productName= this.codeQuery.cpmctymc;
      filterDetail(this.codeQuery).then((res) => {
        this.codeDetailLoading = false;
        if (res.code === 20000) {
          this.codeDetailList = res.data.list || [];
          this.codeTotal = res.data.total || 0;
        } else {
          this.$message.error(res.message);
          this.codeDetailList = [];
          this.codeTotal = 0;
        }
      }).catch((error) => {
        this.codeDetailLoading = true;
        this.$message.error(error.message);
        this.codeDetailList = [];
        this.codeTotal = 0;
      })
    },

    findMethod(query) {
      this.fromOptions = [];
      let cQuery = {
        key: query,
        corpType: 2,
        page: 1,
        limit: 10,
      };
      getBasicUnitMaintains(cQuery)
        .then((response) => {
          this.loading = false;
          this.fromOptions = response.data.list || [];
        })
        .catch(() => {
          this.loading = false;
          this.fromOptions = [];
        });
    },

  },
  filters: {
    statusFilterType(status) {
      const statusMap = {
        false: "success",
        true: "warning",
      };
      return statusMap[status];
    },
  },
  mounted() {
    document.body.ondrop = function (event) {
      event.preventDefault();
      event.stopPropagation();
    };
  },
  created() {

    let supId = this.$store.getters.customerId;
    if (supId == "110") {
      this.showSup = true;
    }
    this.getList();
  },
};
</script>

<style type="text/scss" lang="scss">
</style>
